use super::{PassiveResponder, PassiveResponse};
use crate::util::debug_say_owned;
use lazy_static::lazy_static;
use regex::Regex;
use serenity::model::channel::Message;
use serenity::prelude::Context;

lazy_static! {
    static ref REGEX: Regex = Regex::new("RE{5,}").unwrap();
}

pub(crate) struct ReeeResponder;

impl PassiveResponder for ReeeResponder {
    fn get_message(
        &self,
        received_msg: String,
        ctx: Context,
        message: Message,
    ) -> Option<PassiveResponse<'_>> {
        if REGEX.is_match(&received_msg) {
            if let Some(guild_id) = &message.guild_id {
                if guild_id == &679888177951277102 {
                    return Some(Box::pin(debug_say_owned(
                        message,
                        ctx,
                        "<:texaspat:680231475928498217>",
                    )));
                }
            }
        }
        None
    }
}
